if (typeof foldersync == 'undefined') {
  var foldersync = {};
};

foldersync.OptionController = {
  
  _prefs:null,
  
  profiles:null,
  _profileuielements:null,
  
  _currentProfile:null,
  
  _changeprofilewkg:null,
  
  createPreferences: function() {
    return {
	    namingstr:null,
		naming:null,
		writePlaylists:null,
		enabledelete:null,
		tracknumdigits:null,
		changecheck:null,
		writecover:null,
		coverfolder:null,
		coverfilename:null,
		m3ufolder:null
	  };
  },
  
  disableProfileUI: function(){
    //Deaktivieren und leeren der UI sobald kein Profil selektiert ist.
    document.getElementById("foldersync-options-sync-profile-Name"               ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-naming"             ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-donaming"           ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-writeM3U"           ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-writeM3U-to"        ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-writeCover"         ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-writeCover-to"      ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-writeCover-filename").disabled=true;
	document.getElementById("foldersync-options-sync-profile-enableDelete"       ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-tracknumdigits"     ).disabled=true;
	document.getElementById("foldersync-options-sync-profile-ChangeCheck"        ).disabled=true;
	
	document.getElementById("foldersync-options-sync-profile-Name"               ).value="";
	document.getElementById("foldersync-options-sync-profile-naming"             ).value="";
	document.getElementById("foldersync-options-sync-profile-donaming"           ).setAttribute("checked",false);
	document.getElementById("foldersync-options-sync-profile-writeM3U"           ).setAttribute("checked",false);
	document.getElementById("foldersync-options-sync-profile-writeM3U-to"        ).value="";
	document.getElementById("foldersync-options-sync-profile-writeCover"         ).setAttribute("checked",false);
	document.getElementById("foldersync-options-sync-profile-writeCover-to"      ).value="";
	document.getElementById("foldersync-options-sync-profile-writeCover-filename").value="";
	document.getElementById("foldersync-options-sync-profile-enableDelete"       ).setAttribute("checked",false);
	document.getElementById("foldersync-options-sync-profile-tracknumdigits"     ).value=0;
	document.getElementById("foldersync-options-sync-profile-ChangeCheck"        ).setAttribute("checked",false);
  },
  
  enableProfileUI: function(){
    //Reaktivieren der UI sobald wieder ein Profil selektiert wird.
    document.getElementById("foldersync-options-sync-profile-Name"               ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-naming"             ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-donaming"           ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-writeM3U"           ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-writeM3U-to"        ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-writeCover"         ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-writeCover-to"      ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-writeCover-filename").disabled=false;
	document.getElementById("foldersync-options-sync-profile-enableDelete"       ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-tracknumdigits"     ).disabled=false;
	document.getElementById("foldersync-options-sync-profile-ChangeCheck"        ).disabled=false;
  },
  
  changeProfile: function(){
    if (this._changeprofilewkg) {return;}
	this._changeprofilewkg=true;
	
	if (document.getElementById("foldersync-options-sync-profilelist").selectedIndex == -1) {this.disableProfileUI();this._currentProfile=-1;this._changeprofilewkg=false;return;}
	this.enableProfileUI();
    
    var crt=document.getElementById("foldersync-options-sync-profilelist").selectedIndex;
	
	document.getElementById("foldersync-options-sync-profilelist").selectedIndex=this._currentProfile;
	
	this.editProfile();	
	
	document.getElementById("foldersync-options-sync-profile-Name"               ).value=this._profileuielements[crt].getAttribute("label");
    document.getElementById("foldersync-options-sync-profile-naming"             ).value=this.profiles[crt].namingstr;
	document.getElementById("foldersync-options-sync-profile-donaming"           ).setAttribute("checked",this.profiles[crt].naming);
	document.getElementById("foldersync-options-sync-profile-writeM3U"           ).setAttribute("checked",this.profiles[crt].writePlaylists);
	document.getElementById("foldersync-options-sync-profile-writeM3U-to"        ).value=this.profiles[crt].m3ufolder;
	document.getElementById("foldersync-options-sync-profile-writeCover"         ).setAttribute("checked",this.profiles[crt].writecover);
	document.getElementById("foldersync-options-sync-profile-writeCover-to"      ).value=this.profiles[crt].coverfolder;
	document.getElementById("foldersync-options-sync-profile-writeCover-filename").value=this.profiles[crt].coverfilename;
	document.getElementById("foldersync-options-sync-profile-enableDelete"       ).setAttribute("checked",this.profiles[crt].enabledelete);
	document.getElementById("foldersync-options-sync-profile-tracknumdigits"     ).value=this.profiles[crt].tracknumdigits;
	document.getElementById("foldersync-options-sync-profile-ChangeCheck"        ).setAttribute("checked",this.profiles[crt].changecheck);
	
	this._currentProfile=crt;
	document.getElementById("foldersync-options-sync-profilelist").selectedIndex=crt;
	
	this._changeprofilewkg=false;
  },
  
  editProfile: function(){
    if (document.getElementById("foldersync-options-sync-profilelist").selectedIndex == -1) {return;}
	
    var syncPref = this.createPreferences();
	syncPref.namingstr=document.getElementById("foldersync-options-sync-profile-naming").value;
	syncPref.naming=document.getElementById("foldersync-options-sync-profile-donaming").getAttribute("checked")=="true";
	syncPref.writePlaylists=document.getElementById("foldersync-options-sync-profile-writeM3U").getAttribute("checked")=="true";
    syncPref.m3ufolder=document.getElementById("foldersync-options-sync-profile-writeM3U-to").value;
	syncPref.writecover=document.getElementById("foldersync-options-sync-profile-writeCover").getAttribute("checked")=="true";
	syncPref.coverfolder=document.getElementById("foldersync-options-sync-profile-writeCover-to").value;
	syncPref.coverfilename=document.getElementById("foldersync-options-sync-profile-writeCover-filename").value;
	syncPref.enabledelete=document.getElementById("foldersync-options-sync-profile-enableDelete").getAttribute("checked")=="true";
	syncPref.tracknumdigits=document.getElementById("foldersync-options-sync-profile-tracknumdigits").value;
	syncPref.changecheck=document.getElementById("foldersync-options-sync-profile-ChangeCheck").getAttribute("checked")=="true";
	
	this.profiles[document.getElementById("foldersync-options-sync-profilelist").selectedIndex]=syncPref;
	
	if (!this._existProfile(document.getElementById("foldersync-options-sync-profile-Name").value)){
	  this._profileuielements[document.getElementById("foldersync-options-sync-profilelist").selectedIndex].setAttribute("label",document.getElementById("foldersync-options-sync-profile-Name").value);
	}
	
	this.onAnyChange();
  },
  
  _existProfile: function(pname){
  	var found=false;
	for (var i=0;i<this._profileuielements.length;i++){
	  if (this._profileuielements[i].getAttribute("label")==pname){found=true;}
	}
	return found
  },
  
  addProfile: function(){
    var syncPref = this.createPreferences();
	syncPref.namingstr=this._prefs.getCharPref("namingString");
	syncPref.naming=this._prefs.getBoolPref("naming");
	syncPref.writePlaylists=this._prefs.getBoolPref("writeM3U");
	syncPref.enabledelete=this._prefs.getBoolPref("enabledelete");
	syncPref.tracknumdigits=this._prefs.getIntPref("trackdigits");
	syncPref.changecheck=this._prefs.getBoolPref("ChangeCheck");
	syncPref.writecover=this._prefs.getBoolPref("writecover");
	syncPref.coverfolder=this._prefs.getCharPref("coverfolder");
	syncPref.coverfilename=this._prefs.getCharPref("coverfilename");
	syncPref.m3ufolder=this._prefs.getCharPref("m3ufolder");
	
	this.profiles.push(syncPref);
	
	var pname="new";
	
	if (this._existProfile(pname)) {
	  var i=2;
	  while(this._existProfile(pname+"."+i)){i++}
	  pname+="."+i;
	}
	
	var uielem = document.createElement("listitem");
	uielem.setAttribute("label",pname);
	document.getElementById("foldersync-options-sync-profilelist").appendChild(uielem);
	this._profileuielements.push(uielem);
    
    document.getElementById("foldersync-options-sync-profilelist").selectedIndex=this._profileuielements.length-1;
	
	this.onAnyChange();
  },
  
  remProfile: function(){
    var sel=document.getElementById("foldersync-options-sync-profilelist").selectedIndex;
    if (sel == -1) {return;}
	
	//Temporr berwachung der Liste deaktivieren
	this._changeprofilewkg=true;
	
	//Aus der Liste entfernen
	document.getElementById("foldersync-options-sync-profilelist").selectedIndex = -1;
	document.getElementById("foldersync-options-sync-profilelist").removeChild(this._profileuielements[sel]);
	
	//Listenberwachung reaktivieren
	this._currentProfile=-1;
	this._changeprofilewkg=false;
	
	//Aus Arrays lschen
	var cprofiles = this.profiles;
	var cui = this._profileuielements;
	
	this.profiles=[];
	this._profileuielements=[];
	
	for (var i=0;i<cprofiles.length;i++) {
	  if (i != sel) {
	    this.profiles.push(cprofiles[i]);
		this._profileuielements.push(cui[i]);
	  }
	}
	
	if (this._profileuielements.length != 0) {
	  if (this._profileuielements.length > sel){
	    document.getElementById("foldersync-options-sync-profilelist").selectedIndex=sel;
	  } else {
	    document.getElementById("foldersync-options-sync-profilelist").selectedIndex=sel-1;
	  }
	} else {
	  document.getElementById("foldersync-options-sync-profilelist").selectedIndex=-1;
	}
	
	this.onAnyChange();
  },
  
  onLoad: function(){
    // Einstellungen laden
    this._prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
    this._prefs = this._prefs.getBranch("extensions.FolderSync.");
	var prefs = this._prefs;
	
	
	//Profiles
	this.profiles=[];
	this._profileuielements=[];
	var profstr=prefs.getCharPref("Profiles");
	var profsplit1=profstr.split(";?&?;");
	
	this._changeprofilewkg=true;
	this._currentProfile=-1;
	
	if (profsplit1[0] != "") {
	  for (var i=0; i<profsplit1.length;i++){
	    var syncPref = this.createPreferences();
	    var profsplit2 = profsplit1[i].split(";!&!;");
	    syncPref.namingstr=unescape(profsplit2[1]);
	    syncPref.naming=unescape(profsplit2[2]);
	    syncPref.writePlaylists=unescape(profsplit2[3]);
	    syncPref.enabledelete=unescape(profsplit2[4]);
	    syncPref.tracknumdigits=unescape(profsplit2[5]);
	    syncPref.changecheck=unescape(profsplit2[6]);
        if (profsplit2.length>7){ // Kompartibilitt fr ltere Versionen
	      syncPref.writecover=unescape(profsplit2[7]);
	      syncPref.coverfolder=unescape(profsplit2[8]);
	      syncPref.coverfilename=unescape(profsplit2[9]);
	      syncPref.m3ufolder=unescape(profsplit2[10]);
	    } else {
	      syncPref.writecover="false";
	      syncPref.coverfolder="%album%";
		  syncPref.coverfilename="cover";
	      syncPref.m3ufolder=".";
		}
	    this.profiles.push(syncPref);
	  
	    var profuie=document.createElement("listitem");
	    profuie.setAttribute("label",unescape(profsplit2[0]));
	    document.getElementById("foldersync-options-sync-profilelist").appendChild(profuie);
	    this._profileuielements.push(profuie);
	  }
	  document.getElementById("foldersync-options-sync-profilelist").selectedIndex=0;
	}
	
	this._changeprofilewkg=false;
	this.changeProfile();
  },
  
  onAccept: function(){
    //Profiles
	var profstr="";
    for (var i = 0; i<this.profiles.length;i++){
	  var syncPref=this.profiles[i];
	  profstr+=this._profileuielements[i].getAttribute("label")+";!&!;"+
	           escape(syncPref.namingstr)+";!&!;"+
			   escape(syncPref.naming)+";!&!;"+
			   escape(syncPref.writePlaylists)+";!&!;"+
			   escape(syncPref.enabledelete)+";!&!;"+
			   escape(syncPref.tracknumdigits)+";!&!;"+
			   escape(syncPref.changecheck)+";!&!;"+
			   escape(syncPref.writecover)+";!&!;"+
			   escape(syncPref.coverfolder)+";!&!;"+
			   escape(syncPref.coverfilename)+";!&!;"+
			   escape(syncPref.m3ufolder);
	  if ((i+1)<this.profiles.length) {profstr+=";?&?;";}
	}
	this._prefs.setCharPref("Profiles",profstr);
  },
  
  onAnyChange: function(){
    //Nicht-Windows Platformen: nderung sofort bernehmen
    if (window.navigator.platform[0]+window.navigator.platform[1]+window.navigator.platform[2] != "Win")
      this.onAccept();
  }
}

window.addEventListener("load", function(e) { foldersync.OptionController.onLoad(e); }, false);
