
// Make a namespace.
if (typeof foldersync == 'undefined') {
  var foldersync = {};
};

var foldersync_debug = false;


/**
 * Controller for pane.xul
 */
foldersync.PaneController = {


_playlists:null,
_playlistselections:null,
_strings:null,
_SelectionString:null,
_SelectionItems:null,
_Selections:null,
_prefs:null,
_namingstr:function(){return this._prefs.getCharPref("namingString");},
_naming:function(){return this._prefs.getBoolPref("naming");},
_writePlaylists:function(){return this._prefs.getBoolPref("writeM3U");},
_enabledelete:function(){return this._prefs.getBoolPref("enabledelete");},
_tracknumdigits:function(){return this._prefs.getIntPref("trackdigits");},
_showSyncAll:null,
_badcharacters:function(){return this._prefs.getComplexValue("badcharacters",Components.interfaces.nsISupportsString).data.split("#");},
_cutoff:function(){return this._prefs.getBoolPref("cutoff");},
_changecheck:function(){return this._prefs.getBoolPref("ChangeCheck");},
profiles:null,
_profileuielements:null,

stdProfileName:function(){var result= null; try{result=this._strings.getString("sync.profiles.default");} catch(e){result="[Default]"} return result;},

_activeSyncTask:null,


  enableUI:function() {
    //Aktiviert Steuerelemente der UO
    try{
      document.getElementById("foldersync-pane-syncbutton").disabled=         false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selections-sync").disabled=    false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selections-add").disabled=     false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selections-del").disabled=     false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selections").disabled=         false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-folder").disabled=             false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-folder-browse").disabled=      false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selection").disabled=          false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-refresh").disabled=            false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-profile").disabled=            false;
    }catch(e){} try{
      document.getElementById("foldersync-pane-cancelbutton").disabled=       true;
    }catch(e){} try{
	  document.getElementById("foldersync-pane-syncbutton-deck").setAttribute("selectedIndex",0);
    }catch(e){}
  },
  
  disableUI:function() {
    //Aktiviert Steuerelemente der UO
    try{
      document.getElementById("foldersync-pane-syncbutton").disabled=         true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selections-sync").disabled=    true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selections-add").disabled=     true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selections-del").disabled=     true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selections").disabled=         true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-folder").disabled=             true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-folder-browse").disabled=      true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-selection").disabled=          true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-refresh").disabled=            true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-profile").disabled=            true;
    }catch(e){} try{
      document.getElementById("foldersync-pane-cancelbutton").disabled=       false;
    }catch(e){} try{
	  document.getElementById("foldersync-pane-syncbutton-deck").setAttribute("selectedIndex",1);
    }catch(e){}
  },
  
  CancelAction:function(){
    if (this._activeSyncTask != null) {
	  this._activeSyncTask.cancel=true;
	}
  },
  
  selectPlaylist:function(){
    //Thread schnappen
    var mainthread = Components.classes["@mozilla.org/thread-manager;1"].getService(Components.interfaces.nsIThreadManager).currentThread;
	
	//User informieren, dass script luft
    document.getElementById("foldersync-pane-selection-size").value=this._strings.getString("sync.calculateplaylistsize");
	
	try{
	  //Alle objekte lesen, prfen, dateigre merken
      var size=0;
	  var size2=0;
	  var filepaths=[];
      for (var i = 0; i < this._playlistselections.length;i++)
      {
	    mainthread.processNextEvent(false);
        if (this._playlistselections[i].getAttribute("checked")=="true")
        {
		  var list = this._playlists[i];
		  for (var j=0;j<list.length;j++){
		    var ent = list.getItemByIndex(j);
            var entpath = decodeURI(ent.getProperty("http://songbirdnest.com/data/1.0#contentURL"));
            if ((entpath[0]+entpath[1]+entpath[2]+entpath[3]+entpath[4]+entpath[5]+entpath[6])=="file://"){
		      //alle gltigen Items aller Playlisten landen nun hier, in variable ent
			  var found=false;
			  for (var x=0;x<filepaths.length;x++){
			    if (filepaths[x]==entpath) {found=true;}
			  }
			  if (!found) {
			    filepaths.push(entpath);
			    size+=ent.getProperty("http://songbirdnest.com/data/1.0#contentLength")*1;
			  }
		    }
			size2+=ent.getProperty("http://songbirdnest.com/data/1.0#contentLength")*1;
		  }
        }
      }
	  
	  //Bei Playlist-Profilen Songs je Playlist zhlen
	  var syncPrefs=this.getProfile(document.getElementById("foldersync-pane-profile").selectedItem.getAttribute("value"));
	  if (syncPrefs.naming){
	    if (syncPrefs.namingstr.split("%playlist%").length>1){
		  size=size2;
		}
	  }
	  
	  //Gre auf MB rechen
	  size=size/1024/1024;
	  //MB/GB anzeige des jeweiligen wertes
	  if (size < 1024) {
	    document.getElementById("foldersync-pane-selection-size").value=size.toFixed(2)+" MB";
	  } else {
	    document.getElementById("foldersync-pane-selection-size").value=(size/1024).toFixed(2)+" GB";
	  }
	} catch (ex) {document.getElementById("foldersync-pane-selection-size").value="?"}
  },
  
  selectProfile:function(profilename) {
  	var foundprofile=false;
	for ( var i = 0; i<this._profileuielements.length;i++){
	  if (this._profileuielements[i].getAttribute("label")==profilename){
	    document.getElementById("foldersync-pane-profile").selectedItem=this._profileuielements[i];
		foundprofile=true;
	  }
	}
	if (!foundprofile){
	  document.getElementById("foldersync-pane-profile").selectedIndex = 0;
	}
  },
  
  getProfile:function(profilenum) {
    var syncPrefs=null;
  	if (profilenum==-1) {
	  syncPrefs=this.createPreferences();
	  
	  syncPrefs.namingstr=this._namingstr();
	  syncPrefs.naming=this._naming();
	  syncPrefs.writePlaylists=this._writePlaylists();
	  syncPrefs.enabledelete=this._enabledelete();
	  syncPrefs.tracknumdigits=this._tracknumdigits();
	  syncPrefs.changecheck=this._changecheck();
	  syncPrefs.writecover=this._prefs.getBoolPref("writecover");
	  syncPrefs.coverfolder=this._prefs.getCharPref("coverfolder");
	  syncPrefs.coverfilename=this._prefs.getCharPref("coverfilename");
	  syncPrefs.m3ufolder=this._prefs.getCharPref("m3ufolder");
	  
	} else {
	  syncPrefs=this.profiles[profilenum];
	  
	  if (syncPrefs.namingstr == "") { syncPrefs.namingstr=this._namingstr(); }
	  if (syncPrefs.naming == "") { syncPrefs.naming=this._naming(); }
	  if (syncPrefs.writePlaylists == "") { syncPrefs.writePlaylists=this._writePlaylists(); }
	  if (syncPrefs.enabledelete == "") { syncPrefs.enabledelete=this._enabledelete(); }
	  if (syncPrefs.tracknumdigits == "") { syncPrefs.tracknumdigits=this._tracknumdigits(); }
	  if (syncPrefs.changecheck == "") { syncPrefs.changecheck=this._changecheck(); }
	  if (syncPrefs.writecover == "") {syncPrefs.writecover=this._prefs.getBoolPref("writecover"); }
	  if (syncPrefs.coverfolder == "") {syncPrefs.coverfolder=this._prefs.getCharPref("coverfolder"); }
	  if (syncPrefs.coverfilename == "") {syncPrefs.coverfilename=this._prefs.getCharPref("coverfilename"); }
	  if (syncPrefs.m3ufolder == "") {syncPrefs.m3ufolder=this._prefs.getCharPref("m3ufolder"); }
	  
	}
	return syncPrefs;
  },

  selectSelection: function() {
    // Wird aufgerufen, wenn der User im Selections-Feld einen Eintrag selektiert oder einfach draufklickt
    var selectionsUI=document.getElementById("foldersync-pane-selections");
    if (selectionsUI.selectedItem)
    {
      var actSelection = this._Selections[selectionsUI.selectedIndex].split("!;&");
      document.getElementById("foldersync-pane-folder").value=actSelection[0];
      this._SelectionString=actSelection[1];
	  this.selectProfile(actSelection[2]);
      this.updateSelection();
    }
  },
  
  addSelection: function() {
    //Fgt neues Element hinzu
    //erzeuge neuen Array
    var actSelection=[];
    // flle Array
    actSelection.push(document.getElementById("foldersync-pane-folder").value);
    this.updateSelectionString();
    actSelection.push(this._SelectionString);
	actSelection.push(document.getElementById("foldersync-pane-profile").selectedItem.getAttribute("label"));
    //baue in liste und _Selections ein
    var listitem = document.createElement("listitem");
    listitem.setAttribute("label", actSelection[0]);
    if (this._showSyncAll){
      listitem.setAttribute("type","checkbox");
    }
    listitem= document.getElementById("foldersync-pane-selections").appendChild(listitem);
    this._SelectionItems.push(listitem);
    var actString = actSelection[0]+"!;&"+actSelection[1]+"!;&"+actSelection[2];
    this._Selections.push(actString);
  },
  
  remSelection: function() {
    //Lscht aus der Selection
    var selectionsUI=document.getElementById("foldersync-pane-selections");
    if (selectionsUI.selectedItem) {
      // Wenn was selectiert ist
      // cache _Selections
      var tselections=this._Selections;
      // baue _Selections neu aud (abzglich zu entfernender Eintrag)
      this._Selections = [];
      
      for (var i=0; i<tselections.length; i++)
      {
        if (i != selectionsUI.selectedIndex)
        {
          this._Selections.push(tselections[i]);
        }
      }
      // lsche Eintrag aus liste
      selectionsUI.removeItemAt(selectionsUI.selectedIndex);
      this._SelectionItems.removeItemAt(selectionsUI.selectedIndex);
    }
  },
  
  syncSelection: function(){

    this.disableUI();
  

    // Der Refresh-Task fr das Syncronisieren einer Auswahl
    var refreshTask = {
      _syncTask:null,
      _ended:null,
      _index:null,
	  
	  _workInProgress:null,
	  
      run: function(){
        // Whrend Sync-Vorgang (nicht 100% abgeschlossen)
        if (this._syncTask._currentvalue!=101)
        {
          // aktualisiere Bars
          if (this._syncTask._currentvalue != 0) {document.getElementById("foldersync-pane-progress").mode="determined";} else {document.getElementById("foldersync-pane-progress").mode="undetermined";}
          document.getElementById("foldersync-pane-progress").value=parseInt(this._syncTask._currentvalue);
          document.getElementById("foldersync-pane-progress-caption").value= parseInt(this._syncTask._currentvalue)+"%";
        }
        else
        {
          if (!this._ended)
          {
            this._ended=true;
            // Wenn Sync-Vorgang abgeschlossen
            // Setze Fortschrittsbalken zurck
            document.getElementById("foldersync-pane-progress").value=0;
            document.getElementById("foldersync-pane-progress-caption").value= "";
            document.getElementById("foldersync-pane-progress").mode="determined";
            // Zeige eventuell aufgetretene Fehler
            if (this._syncTask._error)
            {
              //alert(foldersync.PaneController._strings.getString(this._syncTask._error)+this._syncTask._message);
			  window.openDialog('chrome://foldersync/content/error.xul','foldersync-error-message','dialog=yes,modal=no,alwaysLowered=no,centerscreen=yes,resizable=yes',foldersync.PaneController._strings.getString(this._syncTask._error),this._syncTask._message);
            }
            //else
            //{
                // Mache Preferences verfgbar:
              var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                      .getService(Components.interfaces.nsIPrefService);
              prefs = prefs.getBranch("extensions.FolderSync.");
              // Wenn kein Fehler aufgetreten ist, setze zuletzt verwendetes Verzeichnis und Playlistauswahl
              prefs.setCharPref("lastfolder",document.getElementById("foldersync-pane-folder").value);
              prefs.setCharPref("lastselection",foldersync.PaneController._SelectionString);
			  prefs.setCharPref("lastProfileName",document.getElementById("foldersync-pane-profile").selectedItem.getAttribute("label"));
            //}
            try {
              var i=this._index+1;
              var out=false;
              while (!out)
              {
                if (foldersync.PaneController._SelectionItems[i].getAttribute("checked")=="true")
                {
                  var actSelection = foldersync.PaneController._Selections[i].split("!;&");
                  document.getElementById("foldersync-pane-folder").value=actSelection[0];
                  foldersync.PaneController._SelectionString=actSelection[1];
				  foldersync.PaneController.selectProfile(actSelection[2]);
                  foldersync.PaneController.updateSelection();
                  out=true;
                }
                else
                {
                  i++;
                }
              }
              this._index=i;
              this._ended=false;
              foldersync.PaneController.startnewSync(this, foldersync.PaneController.getProfile(document.getElementById("foldersync-pane-profile").selectedItem.getAttribute("value")));
            } catch (e)
            {
              foldersync.PaneController.enableUI();
            }
          }
        }
		this._workInProgress=false;
      }
    }
    
    
    try {
      var i=0;
      var out=false;
      while (!out)
      {
        if (this._SelectionItems[i].getAttribute("checked")=="true")
        {
          var actSelection = this._Selections[i].split("!;&");
          document.getElementById("foldersync-pane-folder").value=actSelection[0];
          this._SelectionString=actSelection[1];
		  this.selectProfile(actSelection[2]);
          this.updateSelection();
          out=true;
        }
        else
        {
          i++;
        }
      }
      refreshTask._index=i;
	  
	  
      this.startnewSync(refreshTask,this.getProfile(document.getElementById("foldersync-pane-profile").selectedItem.getAttribute("value")));
    } catch (e) {
      // Entsperre Sync-Button bei fehlern wieder
      //alert("An Internal Error occured:\n\n"+e);
	  window.openDialog('chrome://foldersync/content/error.xul','foldersync-error-message','dialog=yes,modal=no,alwaysLowered=no,centerscreen=yes,resizable=yes',"Internal Error.",e);
	  this.enableUI();
    }
  },
  
  startnewSync: function(refreshTask,syncPrefs) {
 
  
    // Das ist die Sync-Thread-Klasse
    var syncTask = this.getASyncTask();
    
    //Statte den neuen Thread fr den Sync-Vorgang mit ntigen Informationen aus.
    syncTask._mediaLists = [];
    for (var i = 0; i < this._playlistselections.length;i++)
    {
      if (this._playlistselections[i].getAttribute("checked")=="true")
      {
        // Wenn selektiert, bergebe die Playliste dem Thread
        syncTask._mediaLists.push(this._playlists[i]);
      }
    }
    this.updateSelectionString();
    // Wenn nichts selektiert wurde, breche mit Fehlermeldung ab
    if (syncTask._mediaLists.length==0) {alert(this._strings.getString("sync.error.noselection"));this.enableUI();return;}
    syncTask._folder = document.getElementById("foldersync-pane-folder").value;
    // Einstellungen bergeben
		
    syncTask._namingstr=syncPrefs.namingstr;
    syncTask._naming=eval(syncPrefs.naming);
    syncTask._writePlaylists=eval(syncPrefs.writePlaylists);
	syncTask._writePlaylistsTo=syncPrefs.m3ufolder;
	syncTask._writeCovers=eval(syncPrefs.writecover);
	syncTask._writeCoversTo=syncPrefs.coverfolder;
	syncTask._writeCoversWithFileName=syncPrefs.coverfilename;
    syncTask._enabledelete=eval(syncPrefs.enabledelete);
    syncTask._tracknumdigits=syncPrefs.tracknumdigits*1;
    syncTask._prefs=this._prefs;
    syncTask._badcharacters=this._badcharacters();
    syncTask._cutoff=this._cutoff();
	syncTask._changecheck=eval(syncPrefs.changecheck);
	syncTask._deletefirst=this._prefs.getBoolPref("deletebefore");
	
	
    //Initialisiere thread(fr Sync-Vorgang) und mainthread (=dieser Thread)
    var thread = Components.classes["@mozilla.org/thread-manager;1"]
                        .getService(Components.interfaces.nsIThreadManager)
                        .newThread(0);
    var mainthread = Components.classes["@mozilla.org/thread-manager;1"]
                        .getService(Components.interfaces.nsIThreadManager)
                        .currentThread;
    // Bringe Sync und Refresh zusammen
    syncTask._refreshTask=refreshTask;
    syncTask._mainThread=mainthread;
    //Bereite Sync vor -> baue dateibume auf (muss im hauptprozess laufen)
    syncTask.init();
	
	this._activeSyncTask=syncTask;
	
    
    // Starte Sync-Vorgang
    if (syncTask._currentvalue!=100) {
      // Wenn kein fehler auftrat (also die Aufgabe noch nicht zu 100% abgeschlossen ist)
      thread.dispatch(syncTask, thread.DISPATCH_NORMAL);
      //mainthread.dispatch(syncTask, mainthread.DISPATCH_NORMAL);
    } else {
      // Fhre auf dem Main-Thread den Refresh-Task aus, falls fehler aufgetreten sind.
      mainthread.dispatch(refreshTask, mainthread.DISPATCH_NORMAL);
    }
  },
  
  getASyncTask: function() {
    return {
      // Variablen, die von auen beeinflusst werden knnen
	  cancel:false,
	  
      _currentvalue:null,
      _mediaLists:null,
      _error:null,
      _folder:null,
      _message:null,
      _tfiles:null,
      _files:null,
      _path:null,
      _tags:null,
      _refreshTask:null,
      _mainThread:null,
      _namingstr:null,
      _naming:null,
      _fpaths:null,
      _writePlaylists:null,
	  _writePlaylistsTo:null,
	  _writeCovers:null,
	  _writeCoversTo:null,
	  _writeCoversWithFileName:null,
      _enabledelete:null,
      _tracknumdigits:null,
      _prefs:null,
      _badcharacters:null,
	  _changecheck:null,
	  _platform:null,
	  _deletefirst:null,
	  _copythese:[],
	  
	  //Protokolliert eine Nachricht in der Error Console
	  _log:function(msg) {
		var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		consoleService.logStringMessage("FolderSync: "+msg);
	  },
      // Vergleicht zwei Dateinamenstrings ohne beachtung der gro/kleinschreibung
      _compfilenames:function(s1,s2){      
        return (s1.toUpperCase()==s2.toUpperCase());
      },
      // berprft einen Tag auf ungeeignete zeichen und korregiert diese
      _checkback:function(got,defreplace){
        var back = got;
        var backs = '';
        if (back==null){back="null";}
		if (back=="null"){if (defreplace) {back=defreplace;}}
        for (var i = 0;i<back.length;i++)
        {
          var bad = false;
          for (var j = 0;j<this._badcharacters.length;j++)
          {
            if (back[i]==this._badcharacters[j])
            {
              backs+='_';
              bad = true;
            }
          }
          if (bad == false) {
            backs+=back[i];
          }
        }
        if (this._cutoff){
          // Am ende Leerzeichen und ersetzte Zeichen abschneiden
          var backs2="";
          var backbuf="";
          for (var z = 0;z<backs.length;z++)
          {
            backbuf+=backs[z];
            if ((backs[z]!='_')&&(backs[z]!=' '))
            {
              backs2+=backbuf;
              backbuf="";
            }
          }
          return backs2;
        }
        else
        {
          return backs;
        }
      },
      
      // Entmommen aus Add-On: Playlist Export VERSION 0.1.1.13
      // http://addons.songbirdnest.com/addon/51
      validateValue:function(val, valtype){
        if(val==""||val==" "||val==null||val=="undefined")
        {
          switch (valtype){
            case 0: return "";
            case 1: return petnotitle;
          }
        }else{
          switch(valtype){
            case 0:return val+" - ";
            case 1:return val;
          }
        }
      },
      
      // Diese Funktion liefert einen String indem jedes a mit b ersetzt wurde
      _exchangeStr:function(gotstr,a,b){
        var tmp = gotstr.split(a);
        var retstr="";
        for (var i = 0;i<tmp.length;i++)
        {
          retstr+=tmp[i];
          // wenn es dannach noch einen teil gibt, hnge einen tag an
          if ((i+1)<tmp.length){
            retstr+=b;
          }
        }
        return retstr;
      },
      // Diese Function liefert einen String mit eingebauten Tag namen
      _parseTagged:function(gotstr,gottags){
        var retstr=gotstr;
        retstr=this._exchangeStr(retstr,"%artist%"     ,gottags.artist);
        retstr=this._exchangeStr(retstr,"%title%"      ,gottags.title);
        retstr=this._exchangeStr(retstr,"%album%"      ,gottags.album);
        retstr=this._exchangeStr(retstr,"%genre%"      ,gottags.genre);
        retstr=this._exchangeStr(retstr,"%rating%"     ,gottags.rating);
        retstr=this._exchangeStr(retstr,"%tracknumber%",gottags.tracknum);
        retstr=this._exchangeStr(retstr,"%playlist%"   ,gottags.playlist);
        retstr=this._exchangeStr(retstr,"%albumartist%",gottags.albumartist);
        retstr=this._exchangeStr(retstr,"%year%"       ,gottags.year);
        retstr=this._exchangeStr(retstr,"%discnumber%" ,gottags.discNumber);
        retstr=this._exchangeStr(retstr,"%disccount%"  ,gottags.discCount);
        retstr=this._exchangeStr(retstr,"%composer%"  ,gottags.composer);
        retstr=this._exchangeStr(retstr,"%producer%"  ,gottags.producer);
        return retstr;
      },
      // Diese Funktion list die Dateien eines Verzeichnisses aus
      _enumFileList:function(cpath){
        var pathE = null; 
        try {
          pathE = cpath.directoryEntries;
        } catch (ex) {
          this._error="sync.error.noaccess"; //"Can't access the files in the specifed folder."
          this._currentvalue=100;
          return;
        }
        // Schreibe alle Dateien, die derzeit in path sind, in files.
        var files = [];
        while(pathE.hasMoreElements())
        {
          var ent = pathE.getNext();
          ent.QueryInterface(Components.interfaces.nsIFile);
          if (ent.isFile()) {
            this._files.push(ent);
            gothere=true;
          }
          if (ent.isDirectory()){
            this._enumFileList(ent);
            gothere=true;
          }
        }
        // schreibe das Verzeichnis selbst hinein, da es gelscht werden knnte, wenn es leer wurde
        this._files.push(cpath);
      },
	  _deleteProcedure:function(files,basval,weight){
          // Lschen von berschssigen Dateien
          for (var i=0;i<files.length;i++)
          {
		    if (this.cancel){
		      this._error="sync.error.cancel";
			  this._message+="\n"+files[i].leafName;
			  continue;
		    }
            //suche, ob datei "zu lschen" ist
            var x = 0;
            var dodelete = true;
            // gehe alle ziel-Dateien (die kopiert wurden) durch und vergleiche leafName, um zu ermitteln ob die datei "zu lschen" (dodelete) ist.
            for (x=0;x<this._fpaths.length;x++)
            {
              if (this._compfilenames(files[i].path,this._fpaths[x])) { dodelete=false; }
            }
			//Der Zielordner soll auch verschont bleiben
			if (this._compfilenames(files[i].path,this._path.path)) { dodelete=false; }
			//Wenn "zu lschen", dann lschen
            if (dodelete) {
              try {
                files[i].remove(false);
				if (foldersync_debug) {this._log("Debug: Deleted File:\n"+files[i].path);}
              } catch (ex) {
                if (ex.result!=Components.results.NS_ERROR_FILE_DIR_NOT_EMPTY) {
                  this._error="sync.error.beginfiles";//"Error while parsing the following files:"
                  this._message+="\n"+files[i].leafName+" "+ex;
                }
              }
            }
            this._currentvalue=basval+weight*(i/files.length);
			if (!this._refreshTask._workInProgress){
			  this._refreshTask._workInProgress = true;
              this._mainThread.dispatch(this._refreshTask, this._mainThread.DISPATCH_NORMAL);
			}
          }
		basval+=weight;
        this._currentvalue=basval;
		return basval;
	  },
	  _copyProcedure:function(basval,weight){
        // Kopieren this._copythese
        for (var i=0;i<this._copythese.length;i++)
        {
		  if (this.cancel){
		    this._error="sync.error.cancel";
			this._message+="\n"+this._copythese[i][0].leafName;
			continue;
		  }
		  var src = this._copythese[i][0];
		  var tmp = this._copythese[i][1];
		  var dest_path = this._copythese[i][2];
		  var dest_name = this._copythese[i][3];
	      try {
			if (this._changecheck)
            {
              //Prfe nderungsdatum der Datei, wenn Original neuer, lsche Kopie, um diese anschlieend zu kopieren.
              //Da FAT nur auf 2 Sekunden genau ist, unterschlage nderungen, die weniger als plusminus 2 Sekunden abweichen
              if (tmp.exists()){
                if ((tmp.lastModifiedTime+2000 < src.lastModifiedTime)||(tmp.lastModifiedTime-2000 > src.lastModifiedTime)) {
				  if (foldersync_debug) {this._log("Debug: Delete File to copy changed File:\n"+tmp.path);}
                  tmp.remove(false);
                }
              }
            }
            if (!tmp.exists() && src.exists()){
			  if (foldersync_debug) {this._log("Debug: Copy File:\n"+src.path+" to "+dest_path.path+" as "+dest_name+"");}
              src.copyTo(dest_path,dest_name);
			  // Fixen von Problemen mit LastModifedTime, unter Win32 fhrt dies zu Fehlfuntion, daher weglassen
			  if (this._platform != "Win32") {
                tmp.lastModifiedTime = src.lastModifiedTime;
			  }
            }
          } catch (ex) {
            if (ex.result!=Components.results.NS_ERROR_FILE_ALREADY_EXISTS){
              this._error="sync.error.beginfiles"; this._message+="\n"+this._copythese[i][1].leafName+" "+ex;
            }
          }
		  
          this._currentvalue=basval+weight*(i/this._copythese.length);
		  if (!this._refreshTask._workInProgress){
		    this._refreshTask._workInProgress = true;
            this._mainThread.dispatch(this._refreshTask, this._mainThread.DISPATCH_NORMAL);
		  }
        }
		basval+=weight;
        this._currentvalue=basval;
		return basval;
	  },
      // Die Syncronisations-Routine
      init: function(){
      
        this._refreshTask._syncTask=this;
		this._refreshTask._workInProgress = true;
        this._mainThread.dispatch(this._refreshTask, this._mainThread.DISPATCH_NORMAL);
		
        // Shorthand
        if (typeof(Cc) == "undefined")
          var Cc = Components.classes;
        if (typeof(Ci) == "undefined")
          var Ci = Components.interfaces;
        if (typeof(Cu) == "undefined")
          var Cu = Components.utils;
        if (typeof(Cr) == "undefined")
          var Cr = Components.results;
        
        if (!window.SBProperties) 
          Cu.import("resource://app/jsmodules/sbProperties.jsm");
        if (!window.LibraryUtils) 
          Cu.import("resource://app/jsmodules/sbLibraryUtils.jsm");
        if (!window.kPlaylistCommands) 
          Cu.import("resource://app/jsmodules/kPlaylistCommands.jsm");      
        
        if (foldersync_debug) {this._log("Debug: FolderSync Thread initialisation started.");}
        
        // keine Nachrichten
        this._message="";
        // Iniialisiere path, der zu syncronisierende Path
        var path = Components.classes["@mozilla.org/file/local;1"].
                createInstance(Components.interfaces.nsILocalFile);
        // Versuche, das Verzeichnis zu laden
        try {
          path.initWithPath(this._folder);
        } catch (ex1) {
            this._error="sync.error.incorrectpath"; //"The path is not correct. Please enter a absoulute directory! Abort."
            this._currentvalue=100;
            return;
        }
        if (!path.exists()) {
          this._error="sync.error.doesntexist"; //"The folder doesn't exist! Abort."
          this._currentvalue=100;
          return;
        }

        // Versuche, die Datei-Liste des Verzeichnisses zu laden
        this._files=[];
        this._enumFileList(path);
        
        // in files steht nun eine liste mit allen dateien
        // nun wird/werden die Playliste(n) in Dateien zerlegt
        
        // parallel luft die Erstellung der Playlist, wenn this._writePlaylists() true ist.
        
        var tfiles = [];
        var tags=[];
        this._fpaths=[];
		//Items sammeln und Quelldateien parsen
        for (var cur = 0; cur < this._mediaLists.length; cur++)
        {
          // Es soll sich ja nichts aufhngen ;)
          this._mainThread.processNextEvent(false);
          
          var list = this._mediaLists[cur];
		  
		  if (foldersync_debug) {this._log("Debug: Enumerate Playlist:\n"+list.name);}
		  
          var ios = Components.classes["@mozilla.org/network/io-service;1"]
                              .getService(Components.interfaces.nsIIOService);
          if (list.length != 0) {
            var fostream=null;
            var m3utext="";
			var prefixstr="";
            if (this._prefs.getBoolPref("doExtendedM3U")){
              m3utext="#EXTM3U"+unescape("\r\n");
            }
            if (this._writePlaylists==true)
            {
              var tmpf= path.clone();
			  var m3urelpath = this._writePlaylistsTo.split("/");
			  var prefix = [];
			  for (var i = 0; i<m3urelpath.length;i++){
			    try {
			      switch (m3urelpath[i]){
				    case ".":break;
				    case "..":prefix.unshift(tmpf.leafName);
					          tmpf=tmpf.parent;
					        break;
					default:  tmpf.append(m3urelpath[i]);
					          prefix.unshift("..");
					          if (!tmpf.exists())
							  {
							    tmpf.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
						      }
							break;
				  }
				} catch (ex){Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage("FolderSync: Playlist Path couldn't be appended: "+ex);}
			  }
			  for (var i = 0; i<prefix.length;i++){
			    prefixstr+=prefix[i]+"/";
			  }
              tmpf.append(list.name+".m3u");
              // Die Playlist vor dem Lschen schtzen
              this._fpaths.push(tmpf.path);
              foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
              foStream.init(tmpf, 0x04 | 0x08 | 0x20, 0600, 0);
            }
            for (var i=0;i<list.length;i++)
            {
              var ent = list.getItemByIndex(i);
              var entpath = decodeURI(ent.getProperty(SBProperties.contentURL));
              if ((entpath[0]+entpath[1]+entpath[2]+entpath[3]+entpath[4]+entpath[5]+entpath[6])=="file://")
              {
                //Wenn der eintrag ein dateiname (file://-prefix) ist, dann schreibe ihn als datei in tfiles
                var uri = ios.newURI(entpath,null,null);
                var entf=uri.QueryInterface(Components.interfaces.nsIFileURL).file;
				if (!entf.exists()){this._log("File not found: "+entf.leafName+"\nFile "+entf.path+" is registered in Library but the File doesn't exist."); continue;}
                tfiles.push(entf);
                var tagline={};
				//Tags...
                tagline.artist=this._checkback(ent.getProperty(SBProperties.artistName),this._prefs.getCharPref("defaultTag.artist"));
                tagline.title=this._checkback(ent.getProperty(SBProperties.trackName),this._prefs.getCharPref("defaultTag.title"));
                tagline.album=this._checkback(ent.getProperty(SBProperties.albumName),this._prefs.getCharPref("defaultTag.album"));
                tagline.genre=this._checkback(ent.getProperty(SBProperties.genre),this._prefs.getCharPref("defaultTag.genre"));
                tagline.rating=this._checkback(ent.getProperty(SBProperties.rating),this._prefs.getCharPref("defaultTag.rating"));
                var ttracknum = new String (this._checkback(ent.getProperty(SBProperties.trackNumber),this._prefs.getCharPref("defaultTag.tracknumber")));
                while (ttracknum.length < this._tracknumdigits)
                {
                  ttracknum = new String("0"+ttracknum);
                }
                tagline.tracknum=ttracknum;
                tagline.playlist=this._checkback(list.name);
                tagline.albumartist=this._checkback(ent.getProperty(SBProperties.albumArtistName),this._prefs.getCharPref("defaultTag.albumartist"));
                tagline.year=this._checkback(ent.getProperty(SBProperties.year),this._prefs.getCharPref("defaultTag.year"));
                tagline.discNumber=this._checkback(ent.getProperty(SBProperties.discNumber),this._prefs.getCharPref("defaultTag.discnumber"));
                tagline.discCount=this._checkback(ent.getProperty(SBProperties.totalDiscs),this._prefs.getCharPref("defaultTag.disccount"));
				tagline.producer=this._checkback(ent.getProperty(SBProperties.producerName),this._prefs.getCharPref("defaultTag.producer"));
				tagline.composer=this._checkback(ent.getProperty(SBProperties.composerName),this._prefs.getCharPref("defaultTag.composer"));
				
				//Cover - Pfad ermitteln
				var coverpath = decodeURI(ent.getProperty("http://songbirdnest.com/data/1.0#primaryImageURL"));
				if (((coverpath[0]+coverpath[1]+coverpath[2]+coverpath[3]+coverpath[4]+coverpath[5]+coverpath[6])=="file://")||
				    ((coverpath[0]+coverpath[1]+coverpath[2]+coverpath[3]+coverpath[4]+coverpath[5]+coverpath[6]+coverpath[7]+coverpath[8]+coverpath[9]+coverpath[10])=="resource://")){
				  var coverfile = ios.newURI(coverpath,null,null).QueryInterface(Components.interfaces.nsIFileURL).file;
				  coverpath=coverfile.path;
				} else {coverpath="null"}
				tagline.cover=coverpath;
				if (foldersync_debug) {this._log("Debug: Enumerated Item:\n"+tagline.title);}
				//Tagline in allgemeinen Tag-Array aufnehmen
                tags.push(tagline);
                if (this._writePlaylists==true)
                {
                  // Dateipfad generieren
                  var filepath="";
                  if (this._prefs.getBoolPref("doPointSlash")){
                    filepath="./";
                  }
				  filepath+=prefixstr;
                  if (this._naming==true)
                  {
                    filepath+=this._parseTagged(this._namingstr,tagline);
                    filepath=this._exchangeStr(filepath,"/",this._prefs.getCharPref("SplitChar"));
                    // Dateiendung vorbereiten
                    var onameparts=entf.leafName.split(".");
                    // Dateiendung anhngen, wenn das Original eine besa
                    if (onameparts.length > 1){
                      filepath+="."+onameparts[onameparts.length-1];
                    }
                  } else {
                    filepath+=entf.leafName;
                  }
                  if (this._prefs.getBoolPref("doExtendedM3U")){
                    m3utext+=unescape("\r\n")+
                      "#EXTINF:"+Math.round(ent.getProperty(SBProperties.duration)/1000000)+","+
                      this.validateValue(ent.getProperty(SBProperties.artistName),0)+
                      ""+this.validateValue(ent.getProperty(SBProperties.trackName),1)+unescape("\r\n");
                  }
                  m3utext+=filepath+""+unescape("\r\n");
                }
              }
            }
            if (this._writePlaylists==true)
            {
              foStream.write(m3utext,m3utext.length);
              if (foStream instanceof Components.interfaces.nsISafeOutputStream) {
                foStream.finish();
              } else {
                foStream.close();
              }
            }
          }
        }
		
        // Kopierziele (nsiFiles und Verzeichnisse) erstellen
        for (var i=0;i<tfiles.length;i++)
        {
		  // Es soll sich ja nichts aufhngen ;)
          this._mainThread.processNextEvent(false);
          // In abhngigkeit von _naming und _namingstr den Zielpfad und -Dateinamen generieren
          var dest_path=path.clone();
          var dest_name="";
          if (this._naming==true){
            // Verzeichnisse werden mit / gekennzeichnet
            var namingp = this._parseTagged(this._namingstr,tags[i]).split("/");
			var namingnp = this._namingstr.split("/");
            // Verzeichnisse durcharbeiten
            if (namingp.length>1){
              for (var j=0;j<(namingp.length-1);j++)
              {
                // Verzeichnisnamen parsen
                var cufolder=namingp[j];
                
                // verzeichnis erstellen, sollte es noch nicht exixtieren
                dest_path.append(cufolder);
				
                if( !dest_path.exists() || !dest_path.isDirectory() ) {
                  try{
                    dest_path.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
                  } catch (ex) {
                    this._error="sync.error.beginfiles"; this._message+="\n[Dir] "+dest_path.path+" "+ex;
                  }
                }
				//Cover
				if ((namingnp[j]==this._writeCoversTo)&&(this._writeCovers)&&(tags[i].cover!="null")) {
				  var covername=this._writeCoversWithFileName;
                  var coverfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				  try {
				    //Datei holen
				    coverfile.initWithPath(tags[i].cover);
					//Dateiname mit Endung vervollstndigen (wenn das Muster keine Endung hat)
					if (covername.split(".").length<=1)
					{
					  var onameparts=coverfile.leafName.split(".");
                      if (onameparts.length > 1){
                        covername+="."+onameparts[onameparts.length-1];
                      }
					}
					//Ziel-Datei parsen
					var covertarget = dest_path.clone();
					covertarget.append(covername);
					//Cover vor lschen schtzen
					this._fpaths.push(covertarget.path);
					//Wenn die Datei existiert, nach blichen Regeln zum zu-kopieren-Array hinzufgen
					if (covertarget.exists()){
					  if ((this._changecheck) && ((covertarget.lastModifiedTime+2000 < coverfile.lastModifiedTime)||(covertarget.lastModifiedTime-2000 > coverfile.lastModifiedTime))) {
					    this._copythese.push([coverfile.clone(),covertarget,dest_path.clone(),covername]);
					  }
					}
					else
					{
					  this._copythese.push([coverfile.clone(),covertarget,dest_path.clone(),covername]);
					}
				  }catch(ex){this._error="sync.error.beginfiles"; this._message+="\n[Cover] "+tags[i].cover+" "+ex;}
				}
              }
            }
            // Dateiendung vorbereiten
            var onameparts=tfiles[i].leafName.split(".");
            // "Vornamen" der Datei parsen
            dest_name=namingp[namingp.length-1];
            // Dateiendung anhngen, wenn das Original eine besa
            if (onameparts.length > 1){
              dest_name+="."+onameparts[onameparts.length-1];
            }
          }
		  //Einschrnkung  Dateiname
		  if (dest_name.length>150) {
		    var temp_name = "";
		    for (var z = 0; z < 128; z++){
			  temp_name+=dest_name[z];
			}
			temp_name+="_";
		    for (var z = dest_name.length-20; z < dest_name.length; z++){
			  temp_name+=dest_name[z];
			}
			dest_name=temp_name;
		  }
          // Endgltiges parsen und hinzufgen in Array
            var tmp=dest_path.clone();
            if (dest_name!=""){
              tmp.append(dest_name);
            } else {
              tmp.append(tfiles[i].leafName);
            }
            this._fpaths.push(tmp.path);
			
			if (tmp.exists()){
              if ((this._changecheck) && ((tmp.lastModifiedTime+2000 < tfiles[i].lastModifiedTime)||(tmp.lastModifiedTime-2000 > tfiles[i].lastModifiedTime))) {
                this._copythese.push([tfiles[i].clone(),tmp,dest_path,dest_name]);
              }
            }
			else
			{
			  
			  this._copythese.push([tfiles[i].clone(),tmp,dest_path,dest_name]);
			}
        }
		
		if (foldersync_debug) {this._log("Debug: FolderSync Thread initialisation ready.");}
		
        // dem Spteren Thread zur verfgung stellen
        this._tfiles=tfiles;
        this._tags=tags;
        this._path=path;
        this._currentvalue=0;
		
		this._platform=window.navigator.platform;
      },
      // Der vom Thread gestartete Kram (Kopiervorgang, Lschvorgang)
      run: function(){
        // initialisieren aus init (damals aus Hauptprozess)
        var files = this._files;
        var tfiles = this._tfiles;
        var path = this._path;
        var tags=this._tags;
		
		if (foldersync_debug) {this._log("Debug: FolderSync Thread started.");}
        // Nun kommt das eigentliche syncronisieren (kopieren und lschen)
		
		var basval = 0; //Variable fr anzahl der fertigen prozente
		var copyval = (((this._copythese.length)/((files.length/30+1)+this._copythese.length))*100).toFixed(0)*1;
		
		
		if ((this._enabledelete)&&(this._deletefirst))
        {
			basval=this._deleteProcedure(files,basval,100-copyval);
        }

		basval=this._copyProcedure(basval,copyval);

        if ((this._enabledelete)&&(!this._deletefirst))
        {
			basval=this._deleteProcedure(files,basval,100-copyval);
        }
        // Fertig -> setze auf 100 %
        this._currentvalue=101;
		//while (this._refreshTask._workInProgress) {}
		this._refreshTask._workInProgress = true;
        this._mainThread.dispatch(this._refreshTask, this._mainThread.DISPATCH_NORMAL);
		
		if (foldersync_debug) {this._log("Debug: FolderSync Thread finished.");}
      }
    };
  },
  
  createPreferences: function() {
    return {
	    namingstr:null,
		naming:null,
		writePlaylists:null,
		enabledelete:null,
		tracknumdigits:null,
		changecheck:null,
		writecover:null,
		coverfolder:null,
		coverfilename:null,
		m3ufolder:null
	  };
  },
  
  SyncAction: function() {
    this.disableUI();
  
    // Der refreshTask fr die einfache Syncronisation
    var refreshTask = {	  
	  
      _syncTask:null,
      _ended:null,
	  
	  _workInProgress:null,
	  
      run: function(){
	    // Whrend Sync-Vorgang (nicht 100% abgeschlossen)
        if (this._syncTask._currentvalue!=101)
        {
          // aktualisiere Bars
          if (this._syncTask._currentvalue != 0) {document.getElementById("foldersync-pane-progress").mode="determined";} else {document.getElementById("foldersync-pane-progress").mode="undetermined";}
          document.getElementById("foldersync-pane-progress").value=parseInt(this._syncTask._currentvalue);
          document.getElementById("foldersync-pane-progress-caption").value= parseInt(this._syncTask._currentvalue)+"%";
        }
        else
        {
          if (!this._ended) {
            this._ended=true;
            // Wenn Sync-Vorgang abgeschlossen
            // Setze Fortschrittsbalken zurck
            document.getElementById("foldersync-pane-progress").value=0;
            document.getElementById("foldersync-pane-progress-caption").value= "";
            document.getElementById("foldersync-pane-progress").mode="determined";
        
            // Zeige eventuell aufgetretene Fehler
            if (this._syncTask._error) {
              //alert(foldersync.PaneController._strings.getString(this._syncTask._error)+this._syncTask._message);
			  window.openDialog('chrome://foldersync/content/error.xul','foldersync-error-message','dialog=yes,modal=no,alwaysLowered=no,centerscreen=yes,resizable=yes',foldersync.PaneController._strings.getString(this._syncTask._error),this._syncTask._message);
            }
            //else
            //{
                // Mache Preferences verfgbar:
              var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                      .getService(Components.interfaces.nsIPrefService);
              prefs = prefs.getBranch("extensions.FolderSync.");
              // Wenn kein Fehler aufgetreten ist, setze zuletzt verwendetes Verzeichnis und Playlistauswahl
              prefs.setCharPref("lastfolder",document.getElementById("foldersync-pane-folder").value);
              prefs.setCharPref("lastselection",foldersync.PaneController._SelectionString);
			  prefs.setCharPref("lastProfileName",document.getElementById("foldersync-pane-profile").selectedItem.getAttribute("label"));
            //}
            foldersync.PaneController.enableUI();
          }
        }
		this._workInProgress=false;
      }
    }
	
    
	var syncPrefs=this.getProfile(document.getElementById("foldersync-pane-profile").selectedItem.getAttribute("value"));

	
    this.startnewSync(refreshTask,syncPrefs);
  },
  
  BrowseFolder: function() {
    // Erstelle FilePicker und setze ihn in den GetFolder-Mode
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, this._strings.getString("sync.browse.title"), nsIFilePicker.modeGetFolder); 
    // Zeige den Dialog   
    var ret = fp.show();
    // Wenn User ok geklickt hat
    if (ret == nsIFilePicker.returnOK || ret == nsIFilePicker.returnReplace) {
      var file = fp.file;
      // eintrag in foldersync-pane-folder
      return document.getElementById("foldersync-pane-folder").value = file.path;
    }
  },

  addToLists: function(playlist) {
    // Smarte Playlists haben eine zweite identitt als simple. also kann man die smart weglassen.
    if (playlist.type!="smart") {
      // wenn noch nicht vorhanden, wird eingefgt
      this._playlists.push(playlist);
      var listitem = document.createElement("listitem");
      listitem.setAttribute("type","checkbox");
      listitem.setAttribute("label", playlist.name);
      listitem=document.getElementById("foldersync-pane-selection").appendChild(listitem);
      this._playlistselections.push(listitem);
    }
  },
  
  refresh: function() {
      // Listen vorbereiten
    if (this._playlistselections)
    {
      this.updateSelectionString();
      var listbox = document.getElementById("foldersync-pane-selection");
      for (var i = 0; i < this._playlistselections.length; i++) {
        listbox.removeChild(this._playlistselections[i]);
      }
    }
    this._playlists = [];
    this._playlistselections = [];

    // Playlisten in liste holen
    
    // Variablen
    var sbILibraryManager=Components.classes["@songbirdnest.com/Songbird/library/Manager;1"].getService(Components.interfaces.sbILibraryManager);
    var libraries=sbILibraryManager.getLibraries();
    var foundLibrary;
    var libraryResource;
    var libraryPlList;
    var tempView;
    var filters;
    // Hole Bibilothek
    foundLibrary=sbILibraryManager.mainLibrary;
    // und dessen MediaList
    libraryPlList=foundLibrary.QueryInterface(Components.interfaces.sbIMediaList);
    // und haue diese erstmal in die Liste
    this.addToLists(libraryPlList);
    // erstelle eine view auf der mediathek
    tempView=libraryPlList.createView();
    filters=tempView.cascadeFilterSet;
    filters.clearAll();
    filters.appendSearch(new Array("*"),1);
    filters.appendFilter("http://songbirdnest.com/data/1.0#isList");
    filters.set(1,new Array("1"),1);
    // Lese Playlisten aus
    for(i=0;i<tempView.length;i++){
      try{
        plList=tempView.getItemByIndex(i);
        plList.QueryInterface(Components.interfaces.sbIMediaList);
        if(plList.name!=" "&&plList.name!=" "&&plList.name!="undefined"&&plList.name!=null){
          this.addToLists(plList);
        }
      }catch(e){}
    }
    // und die ganze prozedur auch mit anderen bibilotheken
    while(libraries.hasMoreElements()){
      foundLibrary=libraries.getNext();
        if(foundLibrary.guid!=sbILibraryManager.mainLibrary.guid){
          libraryPlList=foundLibrary.QueryInterface(Components.interfaces.sbIMediaList);
          this.addToLists(libraryPlList);
          tempView=libraryPlList.createView();
          filters=tempView.cascadeFilterSet;
          filters.clearAll();
          filters.appendSearch(new Array("*"),1);
          filters.appendFilter("http://songbirdnest.com/data/1.0#isList");
          filters.set(1,new Array("1"),1);
          for(i=0;i<tempView.length;i++){
            plList=tempView.getItemByIndex(i).QueryInterface(Components.interfaces.sbIMediaList);
            if(plList.name!=""&&plList.name!=" "&&plList.name!="undefined"&&plList.name!=null){
              this.addToLists(plList);
            }
          }
        }
    }
    this.updateSelection();
  },

  onLoad: function() {
    this._initialized = true;

    var controller = this;

    // Shorthand
    if (typeof(Cc) == "undefined")
      var Cc = Components.classes;
    if (typeof(Ci) == "undefined")
      var Ci = Components.interfaces;
    if (typeof(Cu) == "undefined")
      var Cu = Components.utils;
    if (typeof(Cr) == "undefined")
      var Cr = Components.results;
      
    if (!window.SBProperties) 
      Cu.import("resource://app/jsmodules/sbProperties.jsm");
    if (!window.LibraryUtils) 
      Cu.import("resource://app/jsmodules/sbLibraryUtils.jsm");
    if (!window.kPlaylistCommands) 
      Cu.import("resource://app/jsmodules/kPlaylistCommands.jsm");

    // Lokalisierungen laden
    this._strings = document.getElementById("foldersync-pane-strings");
    
    // Einstellungen laden
    this._prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
    this._prefs = this._prefs.getBranch("extensions.FolderSync.");
    
    var prefs=this._prefs;
    
    // Kompartibilitt fr die Sidebar
	if (Components.classes["@songbirdnest.com/Songbird/DisplayPane/Manager;1"].getService(Components.interfaces.sbIDisplayPaneManager).getInstantiatorForWindow(window).contentGroup!="contentpane"){
      //Orients
      document.getElementById("foldersync-pane-mainUIbox").orient="vertical";
      document.getElementById("foldersync-pane-mainUIsplitter").orient="vertical";
      document.getElementById("foldersync-pane-selections-buttonbox").orient="horizontal";
      document.getElementById("foldersync-pane-selections-mainbox").orient="vertical";
      document.getElementById("foldersync-pane-folder-area").orient="vertical";
      document.getElementById("foldersync-pane-playlist-area").orient="vertical";
      
      
      //Sortiererei
	  document.getElementById("foldersync-pane-playlist-area").appendChild(document.createElement("separator"));
      document.getElementById("foldersync-pane-playlist-area").appendChild(document.getElementById("foldersync-pane-selection-caption"));
	  document.getElementById("foldersync-pane-playlist-area").appendChild(document.getElementById("foldersync-pane-selection-box"));
	  document.getElementById("foldersync-pane-playlist-area").appendChild(document.getElementById("foldersync-pane-selection-sizebox"));
      document.getElementById("foldersync-pane-playlist-area").appendChild(document.getElementById("foldersync-pane-refresh"));
	  document.getElementById("foldersync-pane-playlist-area").appendChild(document.createElement("separator"));
	  document.getElementById("foldersync-pane-playlist-area").appendChild(document.getElementById("foldersync-pane-profile-box"));
	  document.getElementById("foldersync-pane-playlist-area").appendChild(document.createElement("separator"));
      
      document.getElementById("foldersync-pane-selections-mainbox").appendChild(document.getElementById("foldersync-pane-selections-buttonbox"));
      
      document.getElementById("foldersync-pane-playlist-area").appendChild(document.getElementById("foldersync-pane-folder-area"));
	  
      
      
      //Autosize
      document.getElementById("foldersync-pane-folder-browse").flex=1;
      document.getElementById("foldersync-pane-syncbutton").flex=1;
    }
    
    if (!prefs.getBoolPref("showHelpLink")){document.getElementById("foldersync-pane-supportbox").removeChild(document.getElementById("foldersync-pane-helplink"));}
    if (!prefs.getBoolPref("showPrefBtn")){document.getElementById("foldersync-pane-supportbox").removeChild(document.getElementById("foldersync-pane-optionlink"));}
	
	//Lade Profile
	
	
	this.profiles=[];
	this._profileuielements=[];
	var profstr=prefs.getCharPref("Profiles");
	var profsplit1=profstr.split(";?&?;");
	
	var dprofuie=document.createElement("menuitem");
	dprofuie.setAttribute("value","-1");
	dprofuie.setAttribute("label",this.stdProfileName());
	document.getElementById("foldersync-pane-profile-popup").appendChild(dprofuie);
	this._profileuielements.push(dprofuie);
	
	
	if (profsplit1[0] != "") {
	for (var i=0; i<profsplit1.length;i++){
	  var syncPref = this.createPreferences();
	  var profsplit2 = profsplit1[i].split(";!&!;");
	  syncPref.namingstr=unescape(profsplit2[1]);
	  syncPref.naming=unescape(profsplit2[2]);
	  syncPref.writePlaylists=unescape(profsplit2[3]);
	  syncPref.enabledelete=unescape(profsplit2[4]);
	  syncPref.tracknumdigits=unescape(profsplit2[5]);
	  syncPref.changecheck=unescape(profsplit2[6]);
	  if (profsplit2.length>7){ // Kompartibilitt fr ltere Versionen
	    syncPref.writecover=unescape(profsplit2[7]);
	    syncPref.coverfolder=unescape(profsplit2[8]);
		syncPref.coverfilename=unescape(profsplit2[9]);
	    syncPref.m3ufolder=unescape(profsplit2[10]);
	  } else {
	    syncPref.writecover="false";
	    syncPref.coverfolder="%album%";
		syncPref.coverfilename="cover";
	    syncPref.m3ufolder=".";
	  }
	  this.profiles.push(syncPref);
	  
	  var profuie=document.createElement("menuitem");
	  profuie.setAttribute("value",i);
	  profuie.setAttribute("label",unescape(profsplit2[0]));
	  document.getElementById("foldersync-pane-profile-popup").appendChild(profuie);
	  this._profileuielements.push(profuie);
	}}
	
	this.selectProfile(prefs.getCharPref("lastProfileName"));
    
    this._showSyncAll=this._prefs.getBoolPref("selectSelections");
    
    document.getElementById("foldersync-pane-folder").value = prefs.getCharPref("lastfolder");
	

	
    this._SelectionString = prefs.getCharPref("lastselection");
    var tselections = prefs.getCharPref("selections");
    var t_selections = tselections.split(";!&");
    this._Selections = [];
    this._SelectionItems = [];
    
    if (t_selections.length != 0)
    {
      for (var i=0; i<t_selections.length;i++)
      {
        if (t_selections[i]!="")
        {
		  //Wandeln von Daten zu Version 2
		  if (t_selections[i].split("!;&").length = 2) {t_selections[i]+="!;&"+this.stdProfileName();}
          this._Selections.push(t_selections[i]);
        }
      }
      for (var i=0; i<this._Selections.length;i++)
      {
        var actSelection = this._Selections[i].split("!;&");
        var listitem = document.createElement("listitem");
        listitem.setAttribute("label", actSelection[0]);
        if (this._showSyncAll==true){
          listitem.setAttribute("type","checkbox");
        }
        listitem= document.getElementById("foldersync-pane-selections").appendChild(listitem);
        this._SelectionItems.push(listitem);
      }
    }
    
    if (this._showSyncAll == false) {
      document.getElementById("foldersync-pane-selections-buttonbox").removeChild(document.getElementById("foldersync-pane-selections-sync"));
    }
    
    try{
      var selsel= prefs.getCharPref("lastSelectionSelection").split(" ");
      if (selsel.length != 0) {
        for (var i=0;i<selsel.length;i++)
        {
          this._SelectionItems[i].setAttribute("checked",selsel[i]);
        }
      }
    } catch (e) {}

    
    this.refresh();
	this.selectPlaylist();
    
    if (prefs.getBoolPref("firstrun")) {prefs.setBoolPref("firstrun",false);alert(this._strings.getString("foldersync.welcome"));}
  },
  
  onLoading: function(){
	this.onLoad();
  },
  
  onUnLoad: function() {
    this._initialized = false;
    
    var prefs = this._prefs;
    
    var newSelection = "";
    if (this._Selections.length != 0)
    {
      for (var i=0;i<this._Selections.length;i++)
      {
        newSelection = newSelection + this._Selections[i] + ";!&";
      }
    }
    prefs.setCharPref("selections", newSelection);
    
    var selectionItem = "";
    if (this._SelectionItems.length != 0)
    {
      for (var i=0;i<this._SelectionItems.length;i++)
      {
        selectionItem += this._SelectionItems[i].getAttribute("checked") + " ";
      }
    }
    prefs.setCharPref("lastSelectionSelection", selectionItem);
  },
  
  updateSelectionString: function() {
    // Beginne bei null
    this._SelectionString="";
    // Gehe die Arrays durch
    if (this._playlists.length != 0)
    {
      for (var i = 0; i<this._playlists.length;i++)
      {
        // Wenn selektiert, schreibe in selectionstring
        if (this._playlistselections[i].getAttribute("checked")=="true")
        {
          this._SelectionString=this._SelectionString+this._playlists[i].guid+"&!;";
        }
      }
    }
  },
  updateSelection: function() {
    // splitte den string
    var selection = this._SelectionString.split("&!;");
    // Gehe die Arrays durch
    if (this._playlists.length != 0)
    {
      for (var i = 0; i<this._playlists.length;i++)
      {
        // Wenn nicht gelistet, ist checked false
        this._playlistselections[i].setAttribute("checked","false");
        // suche in selection
        if (selection.length != 0)
        {
          for (var j = 0; j < selection.length; j++)
          {
            if (selection[j]==this._playlists[i].guid)
            {
              // wenn in selection vorhanden, ist checked true
              this._playlistselections[i].setAttribute("checked","true");
            }
          }
        }
        //document.getElementById("foldersync-pane-selection").appendChild(this._playlistselections[i]);
      }
    }
  }
};

window.addEventListener("load", function(e) { foldersync.PaneController.onLoading(e); }, false);
window.addEventListener("unload", function(e) { foldersync.PaneController.onUnLoad(e); }, false);